Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 4099)
@@ -498,5 +424,5 @@
          CALL lbc_lnk( smv_i(:,:,jl), 'T', 1. )
          CALL lbc_lnk( oa_i(:,:,jl) , 'T', 1. )
-         !
+
          CALL lbc_lnk( ht_i(:,:,jl) , 'T', 1. )
          CALL lbc_lnk( ht_s(:,:,jl) , 'T', 1. )
@@ -515,4 +441,9 @@
          a_i(:,:,jl) = tms(:,:) * a_i(:,:,jl)
       END DO
+      
+      at_i (:,:) = 0.0_wp
+      DO jl = 1, jpl
+         at_i (:,:) = at_i (:,:) + a_i (:,:,jl)
+      END DO
 
       CALL lbc_lnk( at_i , 'T', 1. )
@@ -521,9 +452,15 @@
       CALL lbc_lnk( fsbbq  , 'T', 1. )
       !
-      CALL wrk_dealloc( jpm, zgfactorn, zgfactors, zhin, zhis )
+      !--------------------------------------------------------------------
+      ! 6) ????                                                           | 
+      !--------------------------------------------------------------------
+      tn_ice (:,:,:) = t_su (:,:,:)
+
       CALL wrk_dealloc( jpi, jpj, zidto )
-      !
+      CALL wrk_dealloc( jpi, jpj, zhemis )
+      CALL wrk_dealloc( jpl,   2, zht_i_ini,  za_i_ini,  zv_i_ini )
+      CALL wrk_dealloc(   2,      zhm_i_ini, zat_i_ini, zvt_i_ini, zhm_s_ini, zsm_i_ini )
+
    END SUBROUTINE lim_istate
-
 
    SUBROUTINE lim_istate_init
@@ -533,17 +470,24 @@
       !! ** Purpose : Definition of initial state of the ice 
       !!
-      !! ** Method :   Read the namiceini namelist and check the parameter 
-      !!             values called at the first timestep (nit000)
-      !!
-      !! ** input  :   namelist namiceini
+      !! ** Method : Read the namiceini namelist and check the parameter 
+      !!       values called at the first timestep (nit000)
+      !!
+      !! ** input : 
+      !!        Namelist namiceini
+      !!
+      !! history :
+      !!  8.5  ! 03-08 (C. Ethe) original code 
+      !!  8.5  ! 07-11 (M. Vancoppenolle) rewritten initialization
       !!-----------------------------------------------------------------------------
-      NAMELIST/namiceini/ ttest, hninn, hginn_u, aginn_u, hginn_d, aginn_d, hnins,   &
-         &                hgins_u, agins_u, hgins_d, agins_d, sinn, sins
+      NAMELIST/namiceini/ ttest, hninn, hnins, hginn, hgins, aginn, agins, sinn, sins
       !!-----------------------------------------------------------------------------
-      !
-      REWIND ( numnam_ice )               ! Read Namelist namiceini 
+
+      ! Define the initial parameters
+      ! -------------------------
+
+      ! Read Namelist namiceini 
+      REWIND ( numnam_ice )
       READ   ( numnam_ice , namiceini )
-      !
-      IF(lwp) THEN                        ! control print
+      IF(lwp) THEN
          WRITE(numout,*)
          WRITE(numout,*) 'lim_istate_init : ice parameters inititialisation '
@@ -551,17 +495,13 @@
          WRITE(numout,*) '   threshold water temp. for initial sea-ice    ttest      = ', ttest
          WRITE(numout,*) '   initial snow thickness in the north          hninn      = ', hninn
-         WRITE(numout,*) '   initial undef ice thickness in the north     hginn_u    = ', hginn_u
-         WRITE(numout,*) '   initial undef ice concentr. in the north     aginn_u    = ', aginn_u          
-         WRITE(numout,*) '   initial  def  ice thickness in the north     hginn_d    = ', hginn_d
-         WRITE(numout,*) '   initial  def  ice concentr. in the north     aginn_d    = ', aginn_d          
          WRITE(numout,*) '   initial snow thickness in the south          hnins      = ', hnins 
-         WRITE(numout,*) '   initial undef ice thickness in the north     hgins_u    = ', hgins_u
-         WRITE(numout,*) '   initial undef ice concentr. in the north     agins_u    = ', agins_u          
-         WRITE(numout,*) '   initial  def  ice thickness in the north     hgins_d    = ', hgins_d
-         WRITE(numout,*) '   initial  def  ice concentr. in the north     agins_d    = ', agins_d          
-         WRITE(numout,*) '   initial  ice salinity       in the north     sinn       = ', sinn
-         WRITE(numout,*) '   initial  ice salinity       in the south     sins       = ', sins
+         WRITE(numout,*) '   initial ice thickness  in the north          hginn      = ', hginn
+         WRITE(numout,*) '   initial ice thickness  in the south          hgins      = ', hgins
+         WRITE(numout,*) '   initial ice concentr.  in the north          aginn      = ', aginn
+         WRITE(numout,*) '   initial ice concentr.  in the north          agins      = ', agins
+         WRITE(numout,*) '   initial  ice salinity  in the north          sinn       = ', sinn
+         WRITE(numout,*) '   initial  ice salinity  in the south          sins       = ', sins
       ENDIF
-      !
+
    END SUBROUTINE lim_istate_init
 
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 4099)
@@ -416,9 +416,11 @@
 
                delta = SQRT( zdd(ji,jj)*zdd(ji,jj) + ( zdt(ji,jj)*zdt(ji,jj) + zzdst*zzdst ) * usecc2 )  
-               deltat(ji,jj) = MAX( SQRT(zdd(ji,jj)**2 + (zdt(ji,jj)**2 + zzdst**2)*usecc2), creepl )
-!!gm faster to replace the line above with simply:
-!!                deltat(ji,jj) = MAX( delta, creepl )
-!!gm end 
-
+               ! MV rewriting
+               ! deltat(ji,jj) = MAX( SQRT(zdd(ji,jj)**2 + (zdt(ji,jj)**2 + zzdst**2)*usecc2), creepl )
+               !!gm faster to replace the line above with simply:
+               !!                deltat(ji,jj) = MAX( delta, creepl )
+               !!gm end  
+               deltat(ji,jj) = delta + creepl
+               ! END MV
                !-Calculate stress tensor components zs1 and zs2 
                !-at centre of grid cells (see section 3.5 of CICE user's guide).
@@ -741,8 +743,12 @@
                   &           - e1v( ji  , jj-1 ) * u_ice2(ji  ,jj-1)  ) / area(ji,jj)
 
-               deltat(ji,jj) = SQRT(    zdd(ji,jj)*zdd(ji,jj)   & 
-                  &                 + ( zdt(ji,jj)*zdt(ji,jj) + zdst(ji,jj)*zdst(ji,jj) ) * usecc2 & 
-                  &                          ) + creepl
-
+!              deltat(ji,jj) = SQRT(    zdd(ji,jj)*zdd(ji,jj)   & 
+!                  &                 + ( zdt(ji,jj)*zdt(ji,jj) + zdst(ji,jj)*zdst(ji,jj) ) * usecc2 & 
+!                  &                          ) + creepl
+               ! MV rewriting
+               delta = SQRT( zdd(ji,jj)*zdd(ji,jj) + ( zdt(ji,jj)*zdt(ji,jj) + zdst(ji,jj)*zdst(ji,jj) ) * usecc2 )  
+               deltat(ji,jj) = delta + creepl
+               ! END MV
+            
             ENDIF ! zdummy
 
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 4099)
@@ -371,4 +371,5 @@
          CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
          t_su(:,:,jl) = z2d(:,:)
+         tn_ice (:,:,:) = t_su (:,:,:)
       END DO
 
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 4099)
@@ -102,5 +102,5 @@
       INTEGER, INTENT(in) ::   kt    ! number of iteration
       !
-      INTEGER  ::   ji, jj           ! dummy loop indices
+      INTEGER  ::   ji, jj, jl           ! dummy loop indices
       INTEGER  ::   ierr, ifvt, i1mfr, idfr           ! local integer
       INTEGER  ::   iflt, ial , iadv , ifral, ifrdv   !   -      -
@@ -145,6 +145,16 @@
 
             !   computation the solar flux at ocean surface
-            zfcm1   = pfrld(ji,jj) * qsr(ji,jj)  + &
-                 &    ( 1._wp - pfrld(ji,jj) ) * fstric(ji,jj) / ( 1.0 - zinda + zinda * iatte(ji,jj) )
+            IF (lk_cpl) THEN ! be carfeful: not being tested yet
+               ! original line
+               !zfcm1 = qsr_tot(ji,jj) + fstric(ji,jj) * at_i(ji,jj)
+               ! new line to include solar penetration (not tested)
+               zfcm1 = qsr_tot(ji,jj) + fstric(ji,jj) * at_i(ji,jj) / ( 1.0 - zinda + zinda * iatte(ji,jj) )
+               DO jl = 1, jpl
+                  zfcm1 = zfcm1 - qsr_ice(ji,jj,jl) * a_i(ji,jj,jl)
+               END DO
+            ELSE
+               zfcm1   = pfrld(ji,jj) * qsr(ji,jj)  + &
+                    &    ( 1._wp - pfrld(ji,jj) ) * fstric(ji,jj) / ( 1.0 - zinda + zinda * iatte(ji,jj) )
+            ENDIF
             ! fstric     Solar flux transmitted trough the ice
             ! qsr        Net short wave heat flux on free ocean
@@ -227,8 +237,13 @@
 
             !  computing freshwater exchanges at the ice/ocean interface
-            zemp =   emp(ji,jj)     * ( 1.0 - at_i(ji,jj)          )  &   ! evaporation over oceanic fraction
-               &   - tprecip(ji,jj) *         at_i(ji,jj)             &   ! all precipitation reach the ocean
-               &   + sprecip(ji,jj) * ( 1. - (pfrld(ji,jj)**betas) )  &   ! except solid precip intercepted by sea-ice
-               &   - fmmec(ji,jj)                                         ! snow falling when ridging
+            IF (lk_cpl) THEN 
+               zemp = - emp_tot(ji,jj) + emp_ice(ji,jj) * ( 1. - pfrld(ji,jj) )    &   !
+                  &   - rdm_snw(ji,jj) / rdt_ice
+            ELSE
+               zemp =   emp(ji,jj)     * ( 1.0 - at_i(ji,jj)          )  &   ! evaporation over oceanic fraction
+                  &   - tprecip(ji,jj) *         at_i(ji,jj)             &   ! all precipitation reach the ocean
+                  &   + sprecip(ji,jj) * ( 1. - (pfrld(ji,jj)**betas) )  &   ! except solid precip intercepted by sea-ice
+                  &   - fmmec(ji,jj)                                         ! snow falling when ridging
+            ENDIF
 
             ! mass flux at the ocean/ice interface (sea ice fraction)
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_dh.F90	(revision 4099)
@@ -84,5 +84,4 @@
       REAL(wp) ::   zdhnm, zhnnew, zhisn, zihic, zzc       !
       REAL(wp) ::   zfracs       ! fractionation coefficient for bottom salt entrapment
-      REAL(wp) ::   zds          ! increment of bottom ice salinity
       REAL(wp) ::   zcoeff       ! dummy argument for snowfall partitioning over ice and leads
       REAL(wp) ::   zsm_snowice  ! snow-ice salinity
@@ -429,5 +428,5 @@
                   zfracs = zswi1  * 0.12 + zswi12 * ( 0.8925 + 0.0568 * LOG( 100.0 * zgrr ) )   &
                      &                   + zswi2  * 0.26 / ( 0.26 + 0.74 * EXP ( - 724300.0 * zgrr ) ) 
-                  zds         = zfracs * sss_m(ii,ij) - s_i_new(ji)
+                  zfracs = MIN( 0.5 , zfracs )
                   s_i_new(ji) = zfracs * sss_m(ii,ij)
                ENDIF ! fc_bo_i
@@ -438,5 +437,5 @@
          DO ji = kideb, kiut
             IF( ( fc_bo_i(ji) + fbif_1d(ji) + qlbbq_1d(ji) ) .LT. 0.0  ) THEN
-               ! New ice salinity must not exceed 15 psu
+               ! New ice salinity must not exceed 20 psu
                s_i_new(ji) = MIN( s_i_new(ji), s_i_max )
                ! Metling point in K
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 4099)
@@ -26,5 +26,4 @@
    USE limthd
    USE limsbc
-   USE limdia
    USE limdiahsb
    USE limwri
@@ -402,7 +401,8 @@
       ! 2.11) Ice salinity
       !---------------------
-      !clem@bug: smv_i should be updated too: smv_i(:,:,:) = smv_i(:,:,:) + sm_i(:,:,:) * ( v_i(:,:,:) - zviold(:,:,:) )
+      ! clem correct bug on smv_i
+      smv_i(:,:,:) = sm_i(:,:,:) * v_i(:,:,:)
+
       IF (  num_sal == 2  ) THEN ! general case
-
          DO jl = 1, jpl
             !DO jk = 1, nlay_i
@@ -410,12 +410,12 @@
                   DO ji = 1, jpi
                      ! salinity stays in bounds
-                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
-                     i_ice_switch    =  1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl) + epsi20))
-                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + 0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
+                     !clem smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
+                     smv_i(ji,jj,jl) = MAX( MIN( s_i_max * v_i(ji,jj,jl), smv_i(ji,jj,jl) ), s_i_min * v_i(ji,jj,jl) )
+                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) + epsi20 ) )
+                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) + s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
                   END DO ! ji
                END DO ! jj
             !END DO !jk
          END DO !jl
-
       ENDIF
 
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 4099)
@@ -26,5 +26,4 @@
    USE limthd
    USE limsbc
-   USE limdia
    USE limdiahsb
    USE limwri
@@ -305,7 +304,7 @@
                      zesum = zesum + e_i(ji,jj,jk,jl)
                   END DO
-                  IF (ind_im .LT. nlay_i ) THEN
-                     smv_i(ji,jj,jl) = smv_i(ji,jj,jl) / ht_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i) )
-                  ENDIF
+                  !clem IF (ind_im .LT. nlay_i ) THEN
+                  !clem   smv_i(ji,jj,jl) = smv_i(ji,jj,jl) / ht_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i) )
+                  !clem ENDIF
                   ht_i(ji,jj,jl) = ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i)
                   v_i(ji,jj,jl)  = ht_i(ji,jj,jl) * a_i(ji,jj,jl)
@@ -532,5 +531,7 @@
       ! 2.11) Ice salinity
       !---------------------
-      !clem@bug: smv_i should be updated too: smv_i(:,:,:) = smv_i(:,:,:) + sm_i(:,:,:) * ( v_i(:,:,:) - zviold(:,:,:) )
+      ! clem correct bug on smv_i
+      smv_i(:,:,:) = sm_i(:,:,:) * v_i(:,:,:)
+
       IF (  num_sal == 2  ) THEN ! general case
          DO jl = 1, jpl
@@ -539,7 +540,8 @@
                   DO ji = 1, jpi
                      ! salinity stays in bounds
-                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
-                     i_ice_switch    =  1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl) + epsi20))
-                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + 0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
+                     !clem smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
+                     smv_i(ji,jj,jl) = MAX( MIN( s_i_max * v_i(ji,jj,jl), smv_i(ji,jj,jl) ), s_i_min * v_i(ji,jj,jl) )
+                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) + epsi20 ) )
+                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) + s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
                   END DO ! ji
                END DO ! jj
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 4099)
@@ -30,4 +30,8 @@
 
    PUBLIC sbc_ice_alloc ! called in iceini(_2).F90
+
+   CHARACTER (len=8), PUBLIC :: cn_iceflx = 'none'                !: Flux handling over ice categories
+   LOGICAL, PUBLIC :: ln_iceflx_ave    = .FALSE. ! Average heat fluxes over all ice categories
+   LOGICAL, PUBLIC :: ln_iceflx_linear = .FALSE. ! Redistribute mean heat fluxes over all ice categories, using ice temperature and albedo
 
 # if defined  key_lim2
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 4099)
@@ -471,6 +471,6 @@
       ! Coupled case: since cloud cover is not received from atmosphere 
       !               ===> defined as constant value -> definition done in sbc_cpl_init
-      fr1_i0(:,:) = 0.18
-      fr2_i0(:,:) = 0.82
+      IF ( ALLOCATED (fr1_i0)) fr1_i0 (:,:) = 0.18
+      IF ( ALLOCATED (fr2_i0)) fr2_i0 (:,:) = 0.82
       !                                                      ! ------------------------- !
       !                                                      !      10m wind module      !   
@@ -931,5 +931,6 @@
       CALL wrk_alloc( jpi,jpj, ztx, zty )
 
-      IF( srcv(jpr_itx1)%laction ) THEN   ;   itx =  jpr_itx1   
+!AC Pour eviter un stress nul sur la glace dans le cas mixed oce-ice
+      IF( srcv(jpr_itx1)%laction .AND. TRIM( sn_rcv_tau%cldes ) == 'oce and ice') THEN   ;   itx =  jpr_itx1   
       ELSE                                ;   itx =  jpr_otx1
       ENDIF
@@ -938,7 +939,8 @@
       IF(  nrcvinfo(itx) == OASIS_Rcv ) THEN
 
-         !                                                      ! ======================= !
-         IF( srcv(jpr_itx1)%laction ) THEN                      !   ice stress received   !
-            !                                                   ! ======================= !
+         !                                                                                              ! ======================= !
+!AC Pour eviter un stress nul sur la glace dans le cas mixes oce-ice
+         IF( srcv(jpr_itx1)%laction .AND. TRIM( sn_rcv_tau%cldes ) == 'oce and ice') THEN               !   ice stress received   !
+            !                                                                                           ! ======================= !
             !  
             IF( TRIM( sn_rcv_tau%clvref ) == 'cartesian' ) THEN            ! 2 components on the sphere
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 4099)
@@ -99,5 +99,7 @@
          
          fr_i(:,:) = tfreez( sss_m ) * tmask(:,:,1)      ! sea surface freezing temperature [Celcius]
-#if defined key_coupled 
+
+! OM : probleme. a_i pas defini dans les cas lim3 et cice
+#if defined key_coupled && defined key_lim2
          a_i(:,:,1) = fr_i(:,:)         
 #endif
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 4099)
@@ -32,4 +32,5 @@
    USE sbcblk_core     ! Surface boundary condition: CORE bulk
    USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
+   USE sbccpl          ! Surface boundary condition: coupled interface
    USE albedo          ! ocean & ice albedo
 
@@ -42,5 +43,4 @@
    USE limitd_me       ! Mechanics on ice thickness distribution
    USE limsbc          ! sea surface boundary condition
-   USE limdia          ! Ice diagnostics
    USE limdiahsb       ! Ice budget diagnostics
    USE limwri          ! Ice outputs
@@ -77,4 +77,35 @@
    !!----------------------------------------------------------------------
 CONTAINS
+
+   FUNCTION fice_cell_ave ( ptab)
+      !!--------------------------------------------------------------------------
+      !! * Compute average over categories, for grid cell (ice covered and free ocean)
+      !!--------------------------------------------------------------------------
+      REAL (wp), DIMENSION (jpi,jpj) :: fice_cell_ave
+      REAL (wp), DIMENSION (jpi,jpj,jpl), INTENT (in) :: ptab
+      INTEGER :: jl ! Dummy loop index
+      
+      fice_cell_ave (:,:) = 0.0_wp
+      
+      DO jl = 1, jpl
+         fice_cell_ave (:,:) = fice_cell_ave (:,:) &
+            &                  + a_i (:,:,jl) * ptab (:,:,jl)
+      END DO
+      
+   END FUNCTION fice_cell_ave
+   
+   FUNCTION fice_ice_ave ( ptab)
+      !!--------------------------------------------------------------------------
+      !! * Compute average over categories, for ice covered part of grid cell
+      !!--------------------------------------------------------------------------
+      REAL (kind=wp), DIMENSION (jpi,jpj) :: fice_ice_ave
+      REAL (kind=wp), DIMENSION (jpi,jpj,jpl), INTENT(in) :: ptab
+
+      fice_ice_ave (:,:) = 0.0_wp
+      WHERE ( at_i (:,:) .GT. 0.0_wp ) fice_ice_ave (:,:) = fice_cell_ave ( ptab (:,:,:)) / at_i (:,:)
+
+   END FUNCTION fice_ice_ave
+
+   !!======================================================================
 
    SUBROUTINE sbc_ice_lim( kt, kblk )
@@ -104,9 +135,29 @@
       REAL(wp) ::   zcoef   ! local scalar
       REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zalb_ice_os, zalb_ice_cs  ! albedo of the ice under overcast/clear sky
+      REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zalb_ice      ! mean albedo of ice (for coupled)
+
+      REAL(wp), POINTER, DIMENSION(:,:) :: zalb_ice_all    ! Mean albedo over all categories
+      REAL(wp), POINTER, DIMENSION(:,:) :: ztem_ice_all    ! Mean temperature over all categories
+      
+      REAL(wp), POINTER, DIMENSION(:,:) :: z_qsr_ice_all   ! Mean solar heat flux over all categories
+      REAL(wp), POINTER, DIMENSION(:,:) :: z_qns_ice_all   ! Mean non solar heat flux over all categories
+      REAL(wp), POINTER, DIMENSION(:,:) :: z_qla_ice_all   ! Mean latent heat flux over all categories
+      REAL(wp), POINTER, DIMENSION(:,:) :: z_dqns_ice_all  ! Mean d(qns)/dT over all categories
+      REAL(wp), POINTER, DIMENSION(:,:) :: z_dqla_ice_all  ! Mean d(qla)/dT over all categories
       !!----------------------------------------------------------------------
 
+      !- O.M. : why do we allocate all these arrays even when MOD( kt-1, nn_fsbc ) /= 0 ?????
+
       IF( nn_timing == 1 )  CALL timing_start('sbc_ice_lim')
 
       CALL wrk_alloc( jpi,jpj,jpl, zalb_ice_os, zalb_ice_cs )
+
+      IF ( ln_cpl .OR. ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+         CALL wrk_alloc( jpi,jpj,jpl, zalb_ice)
+      END IF
+      IF ( ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+         CALL wrk_alloc( jpi,jpj, ztem_ice_all, zalb_ice_all, z_qsr_ice_all, z_qns_ice_all, z_qla_ice_all, z_dqns_ice_all, z_dqla_ice_all)
+      ENDIF
+
 
       IF( kt == nit000 ) THEN
@@ -139,4 +190,14 @@
             t_su(:,:,jl) = t_su(:,:,jl) +  rt0 * ( 1. - tmask(:,:,1) )
          END DO
+
+         IF ( ln_cpl ) zalb_ice (:,:,:) = 0.5 * ( zalb_ice_cs (:,:,:) +  zalb_ice_os (:,:,:) )
+         
+         IF ( ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+            !
+            ! Compute mean albedo and temperature
+            zalb_ice_all (:,:) = fice_ice_ave ( zalb_ice (:,:,:) ) 
+            ztem_ice_all (:,:) = fice_ice_ave ( tn_ice   (:,:,:) ) 
+            !
+         ENDIF
                                                      ! Bulk formulea - provides the following fields:
          ! utau_ice, vtau_ice : surface ice stress                     (U- & V-points)   [N/m2]
@@ -161,5 +222,49 @@
                &                      tprecip   , sprecip   ,                            &
                &                      fr1_i0    , fr2_i0    , cp_ice_msh, jpl  )
+            !
+         CASE ( 5 )
+            zalb_ice (:,:,:) = 0.5 * ( zalb_ice_cs (:,:,:) +  zalb_ice_os (:,:,:) )
+            
+            CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )
+
+            CALL sbc_cpl_ice_flx( p_frld=ato_i, palbi=zalb_ice, psst=sst_m, pist=tn_ice    )
+
+            ! Latent heat flux is forced to 0 in coupled :
+            !  it is included in qns (non-solar heat flux)
+            qla_ice  (:,:,:) = 0.0e0_wp
+            dqla_ice (:,:,:) = 0.0e0_wp
+            !
          END SELECT
+
+         ! Average over all categories
+         IF ( ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+
+            z_qns_ice_all  (:,:) = fice_ice_ave ( qns_ice  (:,:,:) )
+            z_qsr_ice_all  (:,:) = fice_ice_ave ( qsr_ice  (:,:,:) )
+            z_dqns_ice_all (:,:) = fice_ice_ave ( dqns_ice (:,:,:) )
+            z_qla_ice_all  (:,:) = fice_ice_ave ( qla_ice  (:,:,:) )
+            z_dqla_ice_all (:,:) = fice_ice_ave ( dqla_ice (:,:,:) )
+
+            DO jl = 1, jpl
+               dqns_ice (:,:,jl) = z_dqns_ice_all (:,:)
+               dqla_ice (:,:,jl) = z_dqla_ice_all (:,:)
+            END DO
+            !
+            IF ( ln_iceflx_ave ) THEN
+               DO jl = 1, jpl
+                  qns_ice  (:,:,jl) = z_qns_ice_all  (:,:)
+                  qsr_ice  (:,:,jl) = z_qsr_ice_all  (:,:)
+                  qla_ice  (:,:,jl) = z_qla_ice_all  (:,:)
+               END DO
+            END IF
+            !
+            IF ( ln_iceflx_linear ) THEN
+               DO jl = 1, jpl
+                  qns_ice  (:,:,jl) = z_qns_ice_all(:,:) + z_dqns_ice_all(:,:) * (tn_ice(:,:,jl) - ztem_ice_all(:,:))
+                  qla_ice  (:,:,jl) = z_qla_ice_all(:,:) + z_dqla_ice_all(:,:) * (tn_ice(:,:,jl) - ztem_ice_all(:,:))
+                  qsr_ice  (:,:,jl) = (1.0e0_wp-zalb_ice(:,:,jl)) / (1.0e0_wp-zalb_ice_all(:,:)) * z_qsr_ice_all(:,:)
+               END DO
+            END IF
+         END IF
 
          !                                           !----------------------!
@@ -264,8 +369,8 @@
          !
          !                                           ! Diagnostics and outputs 
-         IF( ( MOD( kt+nn_fsbc-1, ninfo ) == 0 .OR. ntmoy == 1 ) .AND. .NOT. lk_mpp )   &
-            &             CALL lim_dia 
-         IF (ln_limdiahsb) CALL lim_diahsb
+         IF (ln_limdiaout) CALL lim_diahsb
+!clem # if ! defined key_iomput
                           CALL lim_wri( 1  )              ! Ice outputs 
+!clem # endif
          IF( kt == nit000 )   CALL iom_close( numrir )  ! clem: close input ice restart file
          IF( lrst_ice )   CALL lim_rst_write( kt )        ! Ice restart file 
@@ -287,4 +392,10 @@
       !
       CALL wrk_dealloc( jpi,jpj,jpl, zalb_ice_os, zalb_ice_cs )
+      IF ( ln_cpl .OR. ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+         CALL wrk_dealloc( jpi,jpj,jpl, zalb_ice)
+      END IF
+      IF ( ln_iceflx_ave .OR. ln_iceflx_linear ) THEN
+         CALL wrk_dealloc( jpi,jpj, ztem_ice_all, zalb_ice_all, z_qsr_ice_all, z_qns_ice_all, z_qla_ice_all, z_dqns_ice_all, z_dqla_ice_all)
+      ENDIF
       !
       IF( nn_timing == 1 )  CALL timing_stop('sbc_ice_lim')
Index: branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4098)
+++ branches/2013/dev_r4028_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 4099)
@@ -84,5 +84,5 @@
       NAMELIST/namsbc/ nn_fsbc   , ln_ana    , ln_flx,  ln_blk_clio, ln_blk_core, ln_cpl,   &
          &             ln_blk_mfs, ln_apr_dyn, nn_ice,  nn_ice_embd, ln_dm2dc   , ln_rnf,   &
-         &             ln_ssr    , nn_fwb    , ln_cdgw , ln_wave , ln_sdw
+         &             ln_ssr    , nn_fwb    , ln_cdgw , ln_wave , ln_sdw, cn_iceflx
       !!----------------------------------------------------------------------
 
@@ -117,4 +117,5 @@
          WRITE(numout,*) '              MFS  bulk  formulation                     ln_blk_mfs  = ', ln_blk_mfs
          WRITE(numout,*) '              coupled    formulation (T if key_sbc_cpl)  ln_cpl      = ', ln_cpl
+         WRITE(numout,*) '              Flux handling over ice categories          cn_iceflx   = ', TRIM (cn_iceflx)
          WRITE(numout,*) '           Misc. options of sbc : '
          WRITE(numout,*) '              Patm gradient added in ocean & ice Eqs.    ln_apr_dyn  = ', ln_apr_dyn
@@ -128,4 +129,19 @@
       ENDIF
 
+      !   Flux handling over ice categories 
+      SELECT CASE ( TRIM (cn_iceflx))
+      CASE ('ave')
+         ln_iceflx_ave    = .TRUE.
+         ln_iceflx_linear = .FALSE.
+      CASE ('linear')
+         ln_iceflx_ave    = .FALSE.
+         ln_iceflx_linear = .TRUE.
+      CASE default
+         ln_iceflx_ave    = .FALSE.
+         ln_iceflx_linear = .FALSE.
+      END SELECT
+      IF(lwp) WRITE(numout,*) '              Fluxes averaged over all ice categories         ln_iceflx_ave    = ', ln_iceflx_ave
+      IF(lwp) WRITE(numout,*) '              Fluxes distributed linearly over ice categories ln_iceflx_linear = ', ln_iceflx_linear
+      !
       !                              ! allocate sbc arrays
       IF( sbc_oce_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_init : unable to allocate sbc_oce arrays' )
@@ -166,4 +182,10 @@
       IF( ( nn_ice == 3 .OR. nn_ice == 4 ) .AND. nn_ice_embd == 0 )   &
          &   CALL ctl_stop( 'LIM3 and CICE sea-ice models require nn_ice_embd = 1 or 2' )
+
+      IF( ln_iceflx_ave .AND. ln_iceflx_linear ) &
+         &   CALL ctl_stop( ' ln_iceflx_ave and ln_iceflx_linear options are not compatible' )
+
+      IF( ( nn_ice ==3 .AND. lk_cpl) .AND. .NOT. ( ln_iceflx_ave .OR. ln_iceflx_linear ) ) &
+         &   CALL ctl_stop( ' With lim3 coupled, either ln_iceflx_ave or ln_iceflx_linear must be set to .TRUE.' )
       
       IF( ln_dm2dc )   nday_qsr = -1   ! initialisation flag
@@ -295,4 +317,6 @@
       CASE(  2 )   ;         CALL sbc_ice_lim_2( kt, nsbc )          ! LIM-2 ice model
       CASE(  3 )   ;         CALL sbc_ice_lim  ( kt, nsbc )          ! LIM-3 ice model
+      !is it useful?
+      !CASE(  4 )   ;         CALL sbc_ice_cice ( kt, nsbc )          ! CICE ice model
       END SELECT                                              
 
